<?php
	if (are_my_mapped_locations_dependencies_installed()) {
		if (isset($_POST["action"]) && $_POST["action"] == "Reset") {
			my_mapped_location_copy_directory(LocationPath::normalize(dirname(__FILE__)."/css"), get_template_directory());  		
		}
		wp_enqueue_script('jquery');
		wp_register_script( 'my-form-script', plugins_url('/admin_js/jquery.form.js', __FILE__) );
		wp_register_script("admin-my-mapped-locations", plugins_url("admin_js/application.js", __FILE__));
	  wp_enqueue_script("admin-my-mapped-locations");

	  wp_register_style("admin-my-mapped-locations", plugins_url("admin_css/style.css", __FILE__));
	  wp_enqueue_style("admin-my-mapped-locations");

		wp_localize_script( 'admin-my-mapped-locations', 'MyMappedLocationsAjax', array(
			'ajax_url' => admin_url('admin-ajax.php')
		));

		$css_content = file_get_contents(get_template_directory_uri()."/my_mapped_locations_css/".get_option("my_mapped_location_current_css_file"));
		if (isset($_POST["css_content"])) {
			$location = get_template_directory()."/my_mapped_locations_css/".get_option("my_mapped_location_current_css_file");
			$css_content = $_POST["css_content"];
			$css_content = str_replace('\"', "\"", $css_content);
			$css_content = str_replace("\'", '\'', $css_content);
			tom_write_to_file($css_content, $location);
		}

	?>
	<div class="wrap">
	<h2>My Mapped Locations - Styling</h2>
	<div class="postbox " style="display: block; ">
	<div class="inside">
	  <form action="" method="post">
	  	<p>
	  		<label for="css_file_selection">Select CSS File</label>
	  		<select id="css_file_selection" name="css_file_selection">
	  			<?php
	  			if ($handle = opendir(get_template_directory()."/my_mapped_locations_css")) {
				    /* This is the correct way to loop over the directory. */
				    while (false !== ($entry = readdir($handle))) {
				        if (preg_match("/\.css$/", $entry)) {
				        	$selected = "";
				        	if (get_option("my_mapped_location_current_css_file") == $entry) {
				        		$selected = "selected";
				        	}
				        	echo "<option value='".$entry."' ".$selected.">".$entry."</option>";
				        }
				    }
				    closedir($handle);
					}
	  			?>
	  		</select>
	  	</p>
	  	<p><label for="css_content">CSS</label><textarea id="css_content" name="css_content"><?php echo($css_content); ?></textarea></p>
	  	<p><input type="submit" value="Update"/></p>
	  </form>

	  <h2>Reset Stylesheets</h2>
	  <p>If you run into any issues with the My Mapped Locations stylesheet, you can reset them by clicking on the reset button below. You will lose your current css changes though, so make sure you do a backup.</p>
	  <form action="" method="post">
	  	<p><input type="submit" name="action" value="Reset"/></p>
	  </form>
	</div>
	</div>
	</div>
<?php } ?>